module MatureFactory::Features::Assemble::Strategies
  class Init < Struct.new(:strategy, :pipe, :top)
    def call
      Enumerator.new do |yielder|
        init_params = strategy.call
        pipe.each do |title, init_proc, id|
          init_attrs = Array(init_params[id.to_sym])
          begin
            layer_object = init_proc.call(*init_attrs)
          rescue => e
            next unless handle_exception(e, id, init_attrs)
          end
          yielder << [title, layer_object, id]
        end
      end.lazy
    end

    def handle_exception(e, id, init_attrs)
      exception = MatureFactory::Features::Assemble.create_init_error(e, id, init_attrs)
      top.exception = exception
      raise exception unless top.ignore_exceptions?
    end
  end
end
